
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Node.js 探秘(二) - 求异存同 / iVAN</title>

    <meta name="description" content="Node.js 探秘(二) - 求异存同 前言 在Node.js 探秘(一)中,我们了解到,Node.js 基于 libuv 实现了 I/O 的异步操作.所以,我们经常写类似下面的代码: fs.readFile('test.txt', function(err, data) { if (err) { //error handle/ } //do something with data. }); 通过回调函数来获得想要的结果. 在我们实际解决问题的时候,往往需要一组操作是有序的,比如:读取配置文件.编写命令行工具等.如果使用回调的方式,会">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Node.js 探秘(二) - 求异存同</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>前言</h2>
<p>在Node.js 探秘（一）中，我们了解到，Node.js 基于 libuv 实现了 I/O 的异步操作。所以，我们经常写类似下面的代码：</p>
<pre><code>fs.readFile('test.txt', function(err, data) {
    if (err) {
        //error handle/
    }

    //do something with data.
});
</code></pre>
<p>通过回调函数来获得想要的结果。</p>
<p>在我们实际解决问题的时候，往往需要一组操作是有序的，比如：读取配置文件、编写命令行工具等。如果使用回调的方式，会使用很多的回调嵌套，使代码变得很难看。为了解决这个问题，我们引入 Promise、yield 等概念，但今天我们不讨论这些，我们讨论下最简单的解决办法， 同步执行 以及 Node.js 如何在异步的架构上实现同步的方法。</p>
<h2>使用同步方法</h2>
<p>翻看下 Node.js 的文档，你会看到类似 <code>**Sync</code> 的方法，这些就是 <code>**</code> 对应的同步版本。我们先简单看下如何使用这些方法。</p>
<p>一般读取文件内容，我们会像文章开头那样异步的处理。如果使用同步方法，则类似于下面这样：</p>
<pre><code>try {
    var data = fs.readFileSync('test.txt');
    //do something with data.
} catch(e) {
    //error handle.
}
</code></pre>
<p>可以看到使用同步方法后，我们需要的数据会在文件操作后直接返回，而不存在 callback 的异步处理。需要注意的是，像上面那样使用同步方法时，异常内容不会在返回值中返回，它会被抛到环境中，需要使用 <code>try...catch</code> 来捕获处理。如果想在返回值中获取异常，可以传入一个 <code>Buffer</code> 实例来储存 raw data，这样返回值就变成了一个数组，第一个元素是字符串形式的结果，第二个元素是 Error 信息。</p>
<p>另外，Node.js 在 v0.12 版本之后，实现了同步进程创建的一系列方法，例如：<code>spawnSync</code>，<code>execSync</code> 等，示例如下：</p>
<pre><code>//异步版本
child_process.exec('ls', function(err, data) {
    if (err) {
        //error handle
    }

    //do something with data
});

//同步版本
try {
    var data = child_process.execSync('ls');
    //do something with data
} catch(e) {
    //error handle
}
</code></pre>
<h2>如何调试 Node.js 源码</h2>
<p>在分析具体内容之前，我们先来做些准备工作。debug 是我们在开发时常用的手段，如果我们在看源码的时候，也能边看，边运行，然后在自己想要的地方停下来，或者按照自己的理解稍作修改，再运行，那一定会大大提高效率，下面笔者介绍下自己的方案（以 MacOS 为例）：</p>
<ol>
<li>首先需要有一份 Node.js 的源码，使用 <code>git clone</code> <a href="https://github.com/nodejs/node" rel="external nofollow noreferrer">Github 的仓库</a>或者去<a href="https://nodejs.org/download/release/" rel="external nofollow noreferrer">这里</a>下载压缩包，都可以。</li>
<li>（解压之后）进入源码目录，运行
<pre><code>./configure
make -j
</code></pre>
<blockquote><p> <code>-j [N]，--jobs[=N]</code> 参数用来提高编译效率，充分利用多核处理器的性能，并行编译，N 为并行的任务数。但它并不是万能的，如果有编译依赖，最好还是用单核编译。</p></blockquote>
</li>
<li>使用你习惯的 IDE 来进行 debug，笔者使用的是 CLion。Debug 配置如下图所示：<br /><a href="http://img4.tbcdn.cn/L1/461/1/c50fa4d59c49e257bd062d296696f4f265ec26ce.jpeg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nNC50YmNkbi5jbi9MMS80NjEvMS9jNTBmYTRkNTljNDllMjU3YmQwNjJkMjk2Njk2ZjRmMjY1ZWMyNmNlLmpwZWc=.jpg"></a>
<p>将执行文件指定到 <code>源码目录/out/Release/</code> 目录下的 node 执行文件，参数为你需要运行的脚本和相应的参数（比如这里我配置了可以手动调用 <code>gc</code>），之后去掉 Before Launch 中的 build。</li>
<li>然后运行 Debug 模式，就可以通过断点和 LLDB 来调试 Node.js 源码了，如图。<br /><a href="http://img1.tbcdn.cn/L1/461/1/0c9d2e9be642d1363fab7fe0582160dfd508374a.jpeg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMS50YmNkbi5jbi9MMS80NjEvMS8wYzlkMmU5YmU2NDJkMTM2M2ZhYjdmZTA1ODIxNjBkZmQ1MDgzNzRhLmpwZWc=.jpg"></a></li>
<li>如果需要更改源码，在更改后再次运行 <code>make</code> 即可。</li>
</ol>
<h2>进入正题</h2>
<p>从 <a href="https://nodejs.org/api/" rel="external nofollow noreferrer">Node.js API</a> 文档中，可以看到，只有 <a href="https://nodejs.org/api/fs.html" rel="external nofollow noreferrer">File System</a> 和 <a href="https://nodejs.org/api/child_process.html" rel="external nofollow noreferrer">Child Process</a> 中有同步的方法，但是两个模块的同步方法实现是不一样的，我们分开来说。</p>
<h3>File System</h3>
<p>File System 相关的方法实现都在 <a href="https://github.com/nodejs/node/blob/master/lib/fs.js" rel="external nofollow noreferrer">lib/fs.js</a> 和 <a href="https://github.com/nodejs/node/blob/master/src/node_file.cc" rel="external nofollow noreferrer">src/node_file.cc</a> 中可以找到。每一个对应的文件操作方法, 比如 read、write、link 等等，都有对应的封装。下面以 <code>read</code> 为例进行讲解：</p>
<p>在 <a href="https://github.com/nodejs/node/blob/master/lib/fs.js" rel="external nofollow noreferrer">lib/fs.js</a> 中我们可以看到，<code>fs.read</code>(<a href="https://github.com/nodejs/node/blob/master/lib/fs.js#L587" rel="external nofollow noreferrer">#L587</a>) 和 <code>fs.readSync</code>(<a href="https://github.com/nodejs/node/blob/master/lib/fs.js#L633" rel="external nofollow noreferrer">#L633</a>) 两个方法实际是很相似的，只不过在调用 C/C++ 层面的 <code>read</code> 方法时，传入的参数不同。</p>
<pre><code>//异步方法
fs.read = function(fd, buffer, offset, length, position, callback) {
    //参数处理
    ...
    var req = new FSReqWrap();
    req.oncomplete = wrapper;

    binding.read(fd, buffer, offset, length, position, req);
}

//同步方法
fs.readSync = function(fd, buffer, offset, length, position, callback) {
    //参数处理
    ...
    var r = binding.read(fd, buffer, offset, length, position);
    ...
}
</code></pre>
<p>可以看到，异步的方法创建了一个 FSReqWrap 对象，同时把回调包裹后赋值在它的 <code>oncomplete</code> 属性上。这个对象就是我们之前说到的请求对象，在 Node.js 中几乎所有异步操作都会传入这样一个对象，下文我们还会看到<code>ProcessWrap</code>，除此之外还有很多其他类型的请求对象。它们的作用就是在和 libuv 相互调用时传递需要的数据。</p>
<p>在 <a href="https://github.com/nodejs/node/blob/master/src/node_file.cc#L1052" rel="external nofollow noreferrer">src/node_file.cc #L1052</a> 的 <code>Read</code> 方法中，会根据传入的第六个参数的类型来判断是同步调用还是异步调用。</p>
<pre><code>static void Read(const FunctionCallbackInfo&lt;Value&gt;&amp; args) {
    //参数处理
    ...
    req = args[5];

    if (req-&gt;IsObject()) {
        ASYNC_CALL(read, req, fd, &amp;uvbuf, 1, pos);
    } else {
        SYNC_CALL(read, 0, fd, &amp;uvbuf, 1, pos)
        args.GetReturnValue().Set(SYNC_RESULT); //调用返回值为错误码，没有则为 0
    }
}
</code></pre>
<p>可以看到，这里面使用了两个宏定义 <code>ASYNC_CALL</code> 和 <code>SYNC_CALL</code>，它们的具体内容也在这个文件中。<a href="https://github.com/nodejs/node/blob/master/src/node_file.cc#L281" rel="external nofollow noreferrer">#L281</a> 和<a href="https://github.com/nodejs/node/blob/master/src/node_file.cc#L295" rel="external nofollow noreferrer">#L295</a>。对于宏定义，可以理解为代码替换，它会在编译时根据传入的参数生成代码到相应的位置。</p>
<pre><code>//ASYNC_CALL
FSReqWrap* req_wrap = FSReqWrap::New(env, req.As&lt;Object&gt;(), #func, dest);
int err = uv_fs_ ## func(env-&gt;event_loop(),
                              &amp;req_wrap-&gt;req_,
                              __VA_ARGS__,
                              After);
//SYNC_CALL
fs_req_wrap req_wrap;
int err = uv_fs_ ## func(env-&gt;event_loop(),
                            &amp;req_wrap.req,
                            __VA_ARGS__,
                            nullptr);
</code></pre>
<p>这两个宏定义的区别在于，异步操作时传入的是一个封装好的请求对象（ FSReqWrap），而同步操作时传入的是一个自定义的结构体（ fs_req_wrap），而且后者在调用 libuv 方法时也没有传入回调函数 <code>After</code>。这里面的缘由，就涉及到 libuv 的具体细节了。</p>
<p>libuv 中的 File System 不同于 <a href="http://nikhilm.github.io/uvbook/networking.html" rel="external nofollow noreferrer">socket operations</a>，它内部使用了阻塞函数，然后通过线程池来调用这些函数，并在应用程序需要交互时通知在事件循环中注册的 watcher，所以 File System 本身是支持同步调用和异步调用两种形式的，它们的区别就在于 是否传入了回调函数。</p>
<p>从 <a href="https://github.com/nodejs/node/blob/master/deps/uv/src/unix/fs.c#L109" rel="external nofollow noreferrer">libuv/fs.c</a> 的 <code>POST</code> 宏中可以看到，当传入回调时，libuv 会通过 <code>uv__work_submit</code> 方法把操作提交到队列中等待执行，而没有回调时，它通过 <code>uv__fs_work</code> 方法直接执行对应操作。</p>
<pre><code>#define POST
do {
  if (cb != NULL) {
    uv__work_submit(loop, &amp;req-&gt;work_req, uv__fs_work, uv__fs_done);
    return 0;
  } else {
    uv__fs_work(&amp;req-&gt;work_req);
    return req-&gt;result;
  }
} while (0)
</code></pre>
<p>另外，这两种方式都是有返回值的，遵循 <a href="http://nikhilm.github.io/uvbook/basics.html#libuv-error-handling" rel="external nofollow noreferrer">libuv error code</a>，但一般在同步调用的形式下不会用到。Node.js 在异步调用时通过判断这个返回值是否小于 0，来传递错误。</p>
<pre><code>if (err &lt; 0) {
    ...
    uv_req-&gt;result = err;
    ...
    After(uv_req);
    ...
}
</code></pre>
<p>再来说说为什么传入的请求对象不同。同步调用时，把需要的参数传入就可以了。但在运行异步回调的时候，是需要给出一个上下文信息的（比如读取到的数据和回调函数），所以通过一个包装的 FSReqWrap 来把信息放在 uv_fs_t 这类对象上，供 libuv 和程序本身使用。</p>
<p>同步方法和异步方法流程区别主要如下图：</p>
<p><a href="http://img2.tbcdn.cn/L1/461/1/d2b0d7efab8c04636e1f682b425801940faf4eb5.jpeg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMi50YmNkbi5jbi9MMS80NjEvMS9kMmIwZDdlZmFiOGMwNDYzNmUxZjY4MmI0MjU4MDE5NDBmYWY0ZWI1LmpwZWc=.jpg"></a></p>
<p><a href="http://img4.tbcdn.cn/L1/461/1/54aae3d9a025398ccfceca0fbe447f393718ad5f.jpeg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nNC50YmNkbi5jbi9MMS80NjEvMS81NGFhZTNkOWEwMjUzOThjY2ZjZWNhMGZiZTQ0N2YzOTM3MThhZDVmLmpwZWc=.jpg"></a></p>
<h3>Child Process</h3>
<p>虽然有 libuv 这样强大的底层库，但是由于它本身的不完善，所以在 v0.12 之后才增加了 sync 相关方法。</p>
<p>因为 <code>exec</code>、<code>execFile</code> 都是基于 <code>spawn</code> 这个方法，所以我们以 <code>spawn</code> 方法为例，来看下异步进程创建是如何实现的。</p>
<p>跟异步实现相关的文件有 <a href="https://github.com/nodejs/node/blob/master/lib/internal/child_process.js" rel="external nofollow noreferrer">internal/child_process.js</a> 和 <a href="https://github.com/nodejs/node/blob/master/src/process_wrap.cc" rel="external nofollow noreferrer">process_wrap.cc</a>，我们一点点来看。</p>
<p>在我们调用的 <code>spawn</code> 实际上最终调用的是 <a href="https://github.com/nodejs/node/blob/master/lib/internal/child_process.js#L252" rel="external nofollow noreferrer">internal/child_process.js</a> 中的 <code>ChildProcess.spawn</code> 方法。<code>ChildProcess</code>的实例会被绑定 <code>onexit</code> 方法，在进程使用完毕后被调用，并且具有 <code>EventEmitter</code> 的 <code>on</code>、<code>emit</code> 等方法，来让使用者获取相应的数据。它的内部存在一个 <code>_handle</code> 对象，它是 <code>ProcessWrap</code> 所对应的 Javascript 对象。</p>
<pre><code>function ChildProcess() {
    ...
    this._handle = new Process(); //Process Req Wraper
    ...
    this._handle.onexit = function(exitCode, signalCode) {
        ...
    }
    ...
}
util.inherits(ChildProcess, EventEmitter);
</code></pre>
<p>在 <code>ProcessWrap</code> 对象中，会处理我们传入的参数以及回调，最终变成一个 <code>options</code> 引用，传入到 <code>uv_spawn</code> 中，最终它来真正完成 <code>spawn</code> 操作。和上面文件操作的异步方法类似（因为都是继承的 AsyncWrap），在执行完成后，会通过<code>MakeCallback</code> 来执行 <code>onexit</code> 回调，在这个回调里面，会根据结果，触发 <code>error</code> 或 <code>exit</code> 事件。而在运行过程中的输出，会通过 <code>pipe</code>（默认）等方式传回来，因为是 stream，所以可以通过监听 <code>data</code> 事件来获取。</p>
<pre><code>static void Spawn(const FunctionCallbackInfo&lt;Value&gt;&amp; args) {
    ...
    options.exit_cb = OnExit;
    ...
    // options.stdio
   ParseStdioOptions(env, js_options, &amp;options);
   ...
   int err = uv_spawn(env-&gt;event_loop(), &amp;wrap-&gt;process_, &amp;options);
   ...
}
</code></pre>
<p><a href="http://img3.tbcdn.cn/L1/461/1/7e4420f3af9105e533b8d48f44fdaacf0b8a04cf.jpeg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMy50YmNkbi5jbi9MMS80NjEvMS83ZTQ0MjBmM2FmOTEwNWU1MzNiOGQ0OGY0NGZkYWFjZjBiOGEwNGNmLmpwZWc=.jpg"></a></p>
<p>当你明白了上面 File System 的异步调用后，Child Porcess 异步的实现会比较容易理解。下面我们来看同步的实现。</p>
<p>我们知道，Node.js 因为有 <code>uv_run</code> 的存在，它会一直循环，处理各种事件。当全部处理完成后，<code>uv_run</code> 结束，Node.js 也随之结束。那么，可以理解为 <code>uv_run</code> 是一个阻塞的方法，会阻塞当前进程的运行。实际上，<code>uv_run</code> 也确实是一个有 while 循环的方法，满足条件（uv__loop_alive &amp;&amp; loop -&gt; stop_flag == 0）就会一直执行。Child Porcess 同步方法的实现，也正是基于了这个特性。</p>
<p>在它的底层实现 <a href="https://github.com/nodejs/node/blob/master/src/spawn_sync.cc" rel="external nofollow noreferrer">spawn_sync.cc</a> 中，可以看到，它创建了一个新的 <code>uv_loop_t</code> 结构对象 <code>uv_loop_</code>，并且通过它来运行 <code>uv_spawn</code> 和 <code>uv_run</code>。这个 <code>uv_run</code> 会阻塞当前的运行进程，直到执行完毕或者超时。因为主进程使用的是<code>default_uv_loop</code>，所以不会干扰主进程事件的处理。</p>
<pre><code>void SyncProcessRunner::TryInitializeAndRunLoop(Local&lt;Value&gt; options) {
    ...
    uv_loop_ = new uv_loop_t;
    ...
    if (timeout_ &gt; 0) {
        ...
        r = uv_timer_init(uv_loop_, &amp;uv_timer_);
        ...
    }
    ...
    uv_process_options_.exit_cb = ExitCallback;
    r = uv_spawn(uv_loop_, &amp;uv_process_, &amp;uv_process_options_);
    ...
    r = uv_run(uv_loop_, UV_RUN_DEFAULT);
}
</code></pre>
<p>这其中还有一个特殊处理，在 <code>uv_run</code> 执行完毕后，会给即将关闭的 watchers 时间来关闭。</p>
<pre><code>void SyncProcessRunner::CloseHandlesAndDeleteLoop() {
    ...
    if (uv_loop_ != nullptr) {
        CloseStdioPipes();
        CloseKillTimer();
        ...
        //让正在关闭的 watcher 完成关闭，这样它们会调用 close 回调。
        int r = uv_run(uv_loop_, UV_RUN_DEFAULT);
        ...
        delete uv_loop_;
        uv_loop_ = nullptr;
    }
    ...
}
</code></pre>
<p><a href="http://img3.tbcdn.cn/L1/461/1/10184bff4df96074c9e17f7a62efcb86357d8a9e.jpeg" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nMy50YmNkbi5jbi9MMS80NjEvMS8xMDE4NGJmZjRkZjk2MDc0YzllMTdmN2E2MmVmY2I4NjM1N2Q4YTllLmpwZWc=.jpg"></a></p>
<p>之后根据执行过程中的输出和执行结果，确定返回给 Javascript 层的结果，经过一系列处理后，返回给调用者，这不是本文重点，就不赘述了。</p>
<h2>后话</h2>
<p>在 Node.js 的 API 中，异步方法的实现都大同小异，使用 AsyncWrap 的子类来和 libuv 交换数据，然后在调用 libuv 中相应的方法来。但相应的同步方法的实现，确各有不同，用到了很多特性，下了很大的功夫。反观需要这些同步方法的场景，读取配置文件、编写命令行工具等，能否在异步框架下完成呢？改变下我们的思维，或许会有更好的解决办法。</p>
<p>注：以上内容基于 Node.js 5.0 源码。</p>
<p>参考资料：</p>
<ul>
<li><a href="https://github.com/nodejs/node/" rel="external nofollow noreferrer">Node.js Sourcecode</a></li>
<li><a href="http://nikhilm.github.io/uvbook/index.html" rel="external nofollow noreferrer">uvbook</a></li>
<li><a href="http://docs.libuv.org/en/v1.x/index.html" rel="external nofollow noreferrer">libuv docs</a></li>
<li><a href="http://www.infoq.com/cn/articles/nodejsv0.12-execsync-a-synchronous-api-for-child-processes" rel="external nofollow noreferrer">Node.js V0.12新特性之给子进程的同步API</a></li>
<li><a href="https://www.google.com/" rel="external nofollow noreferrer">Google</a></li>
</ul>
<p>该文章来自于阿里巴巴技术协会（ATA）</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-28 18:27:48</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e9%98%bf%e9%87%8c%e6%8a%80%e6%9c%af%e5%8d%8f%e4%bc%9a/" title="阿里技术协会">阿里技术协会</a>, <a href="https://www.iamivan.net/tag/%e5%89%8d%e7%ab%af%e4%b8%8e%e4%ba%a4%e4%ba%92%e8%ae%be%e8%ae%a1/" title="前端与交互设计">前端与交互设计</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Node.js 探秘(二) - 求异存同的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJkmY7b.html" rel="bookmark">Node&period;js 探秘（一）- 初识单线程的 Node&period;js</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 从Node.js进入人们的视野时,我们所知道的它就由这些关键字组成 事件驱动.非阻塞I/O.高效.轻量,它在官网中也是这么描述自己的. Node.js is a JavaScript runtime built on Chrome's V8 JavaScript engine. Node.js uses an event-driven,non-blocking I/O model that makes it lightweight and efficient. 于是,会有下面的场景出现:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pXdvPWp.html" rel="bookmark">Node&period;js文件操作二</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前面的博客 Node.js文件操作一中主要是对文件的读写操作,其实还有文件这块还有一些其他操作. 一.验证文件path是否正确(系统是如下定义的) fs.exists = function(path, callback) { if (!nullCheck(path, cb)) return; var req = new FSReqWrap(); req.oncomplete = cb; binding.stat(pathModule._makeLong(path), req); function			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b32NVwz.html" rel="bookmark">跟我学Nodejs（二）--- Node&period;js事件模块&lowbar;javascript技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				简介及资料 http://nodejs.org/api/events.html http://www.infoq.com/cn/articles/tyq-nodejs-event     events是node.js 最重要的模块,events模块只提供了一个对象events.EventEmitter,EventEmitter 的核心是事件发射与事件监听器.     Node.js中大部分的模块,都继承自Event模块.     与DOM树上事件不同,不存在事件冒泡.逐层捕获等行为.     E			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGZ61lp.html" rel="bookmark">用C&sol;C&plus;&plus;来实现 Node&period;js 的模块（二）&lowbar;node&period;js</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				温故而知新,可以为湿矣 首先请大家记住这个 V8 的在线手册--http://izs.me/v8-docs/main.html. 还记得上次的 building.gyp 文件吗? 复制代码 代码如下: {   &quot;targets&quot;: [     {       &quot;target_name&quot;: &quot;addon&quot;,       &quot;sources&quot;: [ &quot;addon.cc&quot; ]     }   ] }   就像这样,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zGjkaop.html" rel="bookmark">Node&period;js和MongoDB实现简单日志分析系统</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  Node.js和MongoDB实现简单日志分析系统  这篇文章主要介绍了Node.js和MongoDB实现简单日志分析系统,本文给出了服务器端.客户端.图表生成.Shell自动执行等功能的实现代码,需要的朋友可以参考下     在最近的项目中,为了便于分析把项目的日志都存成了JSON格式.之前日志直接存在了文件中,而MongoDB适时闯入了我的视线,于是就把log存进了MongoDB中.log只存起来是没有意义的,最关键的是要从日志中发现业务的趋势.系统的性能漏洞等.之前有一个用Java写的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M1EgYjM.html" rel="bookmark">穆客带你快速定位Node&period;js内存泄露</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在7月7日的云栖TechDay活动上,来自阿里云的穆客给大家分享了&lt;如何快速定位Node.js内存泄露&gt;话题.此次分享主要包括Node.js和APM的简单介绍.Node.js内存管理.Node.js内存泄露及其排查过程四个方面. 下面是现场分享观点整理. 大家好,我是来自阿里云的穆客,今天分享的是关于Node.js方面的故障排查.内存泄露的话题. Node.js和APM 很多人应该都知道Node.js,它是一个运行于服务端的基于Chrome V8引擎的 JavaScript 运行环境,Node			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MxWBPQb.html" rel="bookmark">《Node&period;js区块链开发》导读</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Preface 前 言 本书原名&lt;Nodejs开发加密货币&gt;,大部分已经通过网络免费分享(网络上仍有原文),正式出版的时候改成了现在的名字,部分章节也做了调整.写作本书的时候,&quot;区块链&quot;这个称呼并不流行,但讨论的内容实际上就是区块链技术.就在本书整理出版的时候,国家发布了&lt;中国区块链技术和应用发展白皮书&gt;,整个社区也接纳了&quot;区块链&quot;这个称谓,因此改为现在的名字. &quot;每一件与众不同的绝世好东西,其实都是以无比寂寞的勤奋为前提的,要么是			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MlQK5Lp.html" rel="bookmark">记一次 Node&period;js 应用内存暴涨分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				起因 之前 TMS 在运行时 CPU 中占用率和内存占用一直很高,导致应用运行状态不是很良好,需要频繁重启.经过排查,找出了部分原因: 使用的 html-minifier 模块有问题,如果输入的内容是一个有错误的 HTML 结构,会使解析进入死循环,导致 CPU 占用率 100%. 在使用 vm 模块时,使用姿势错误,导致内存占用无法释放,使内存占用暴涨. 第一个问题我们今天不予讨论,主要来说一下第二个问题. VM(Virtual Machine) 模块 我们就先了解下 VM 这个模块. 从它的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pkegwEb.html" rel="bookmark">Node&period;js中内存泄漏分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				内存泄漏(Memory Leak)指由于疏忽或错误造成程序未能释放已经不再使用的内存的情况.如果内存泄漏的位置比较关键,那么随着处理的进行可能持有越来越多的无用内存,这些无用的内存变多会引起服务器响应速度变慢,严重的情况下导致内存达到某个极限(可能是进程的上限,如 v8 的上限:也可能是系统可提供的内存上限)会使得应用程序崩溃. 传统的 C/C++ 中存在野指针,对象用完之后未释放等情况导致的内存泄漏.而在使用虚拟机执行的语言中如 Java.JavaScript 由于使用了 GC (Garbag			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM62JoM.html" rel="bookmark" class="title">百度SEM竞价常用公式</a>
					<div>
						在http://www.aliyun.com/zixun/aggregation/8485.html&quot;&gt;搜索引擎营销SEM过程中我们会经常遇到一些关键指标,对于这些指标如果能够理解并充 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VMrvmvM.html" rel="bookmark" class="title">asp&period;net 网站运行很慢 很慢  为什么会这样  应该设置什么？   怎么设置呢？</a>
					<div>
						问题描述 asp.net 网站运行很慢 很慢 为什么会这样 应该设置什么? 怎么设置呢? asp.net 网站运行很慢很慢 是什么原因? 应该设置什么? 怎么设置呢? 解决方案 这个原因多了去了,比如 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/YbKaAEp.html" rel="bookmark" class="title">看人家用使用InstallShield制作ASP安装程序&lpar;6&rpar;</a>
					<div>
						installshield|程序 //////////////////////////////////////////////////////////////////////////////////  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6K13z.html" rel="bookmark" class="title">两种制作系统快速启动的方法</a>
					<div>
						现在网上有很多快速启动工具,但这样的工具都会消耗系统资源,其实微软件操作系统本身就有此功能,我目前使用了两种快速启动栏工具: 一.效果如图一 制作方法: 1.将所有的快捷方式放到一个文件夹中,文件夹名 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zZO4m4b.html" rel="bookmark" class="title">mysql中UNIX&lowbar;TIMESTAMP&lpar;&rpar;函数和php中time&lpar;&rpar;函数的区别</a>
					<div>
						mysql 中:UNIX_TIMESTAMP(), UNIX_TIMESTAMP(date) 若无参数调用,则返回一个 Unix timestamp ('1970-01-01 00:00:00' GM ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Ar1np.html" rel="bookmark" class="title">Struts框架之构建Model组件</a>
					<div>
						一.概述 Model就是在对用户请求的整个控制过程中,真正处理用户请求并保存处理结果的对象,在整个过程中,我们一般利用JavaBean来把一些信息保存起来以便在各个对象之间传递.因为在框架中,Mode ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgKgRAM.html" rel="bookmark" class="title">CLR探索系列</a>
					<div>
						只有深究最本质的东西,才能把握最本质的东西. 有很多朋友都分析过System.Object作为Dotnet Framework里面的一个基类,她的特性.方法特点及其相关的概念,这篇博文里面,我就从Sy ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrKjWmp.html" rel="bookmark" class="title">CSS UL LI布局实现表格效果</a>
					<div>
						  今天带了一篇简短的教程,用CSS的UL LI制作实现一个表格,以往听说CSS实现表格并不好,还不如直接用传统的TABLE来实现,其实我不这么认为,如果你CSS非常熟练了,用CSS来实现表格同样很省 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pk23OwM.html" rel="bookmark" class="title">jquery图片切换实例分析</a>
					<div>
						 本文实例讲述了jquery图片切换实现方法.分享给大家供大家参考.具体如下:   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZxE4z.html" rel="bookmark" class="title">爱剪辑如何去掉视频里的声音？</a>
					<div>
						  视频的声音能不能去掉呢?下面跟小编一起来看看怎么用爱剪辑简单地去掉视频声音. 打开爱剪辑添加视频,然后在视频列表和视频预览框中间位置,在&quot;声音设置&quot;栏目,将&quot;使用音轨 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE6ryPM.html" rel="bookmark" class="title">Clojure的transient集合</a>
					<div>
						  下班后记一些有趣的东西.     这个话题是阿宝同学问我为什么clojure的PersistentVector的节点Node为什么要有个原子引用指向一个线程: static class Node  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NGeWz.html" rel="bookmark" class="title">如何使用TapiLib&period;dll</a>
					<div>
						问题描述 我要在下面的代码中使用TapiLib.dll,因为里面有Tapi和Line类:怎么办???publicstructGeneralInfo{publicstringManufacturer;/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrVjVM.html" rel="bookmark" class="title">基础-被检测到内网IP端口不通，从我的电脑也无法访问到我的IP端口，怎么破？</a>
					<div>
						问题描述 被检测到内网IP端口不通,从我的电脑也无法访问到我的IP端口,怎么破? 在此基础上,让我检查是否开启应用服务端口,可是它在哪里...ps,我家是铁通宽带,网络龟速 解决方案 检查下分配给你的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL7Rd0M.html" rel="bookmark" class="title">构建ASP&period;NET MVC4&plus;EF5&plus;EasyUI&plus;Unity2&period;x注入的后台管理系统（8）-MVC与EasyUI DataGrid 分页</a>
					<div>
						原文:构建ASP.NET MVC4+EF5+EasyUI+Unity2.x注入的后台管理系统(8)-MVC与EasyUI DataGrid 分页 上一节我们讲了,DataGrid获取数据的一些用法,这 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7ZE3ap.html" rel="bookmark" class="title">mysql备份</a>
					<div>
						  mysql备份分为逻辑备份和物理备份        1.逻辑备份              通过mysqldump等导出数据的备份方法       2.物理备份             通过直接拷 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOmQaQM.html" rel="bookmark" class="title">算法 数据结构 图论-问一个算法问题，将一个数变为另一个数的最少步骤</a>
					<div>
						问题描述 问一个算法问题,将一个数变为另一个数的最少步骤 &quot;上上下下左右左右 BABA&quot;中,上用↑表示,下用↓表示,左用←表示,右用→表示,A, B.先定义一个输入区,模拟 6 位 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgR8WBb.html" rel="bookmark" class="title">logistic回归</a>
					<div>
						回归就是对已知公式的未知参数进行估计.比如已知公式是y=a∗x+by=a∗x+b,未知参数是a和b,利用多真实的(x,y)训练数据对a和b的取值去自动估计.估计的方法是在给定训练样本点和已知的公式后, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJA0Z8p.html" rel="bookmark" class="title">《UML面向对象设计基础》&mdash;第2章2&period;5节本章小结</a>
					<div>
						2.5 本章小结 UML面向对象设计基础 在面向对象中有一种说法,即面向对象构件与电子集成电路有些类似.至少在软件中有机会象现代电子工程师那样构造系统:可以通过预制构件的连接实现有效的抽象.但为了实现 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwJRgOp.html" rel="bookmark" class="title">佳能600D相机镜头能和佳能550D通用问题详解</a>
					<div>
						给各位摄影爱好者们来详细的解析分享一下佳能600D相机的镜头能和佳能550D相机通不通用的问题. 解析分享: 佳能600D的镜头可以用在佳能550D相机上.因为现在只有相机品牌和品牌直接的镜头不能通用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bodlwXM.html" rel="bookmark" class="title">《Scala机器学习》一一3&period;5　Spark的性能调整</a>
					<div>
						3.5 Spark的性能调整 虽然数据管道的高效执行是任务调度器优先考虑的,这是Spark驱动的一部分,有时Spark需要人为给出一些提示.Spark调度主要与两个参数有关:CPU和内存.当然其他资源 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zeo90NM.html" rel="bookmark" class="title">允许用户将 Xbox Music Store 中没有的音乐上传至前者</a>
					<div>
						微软正将旗下在线文件存储服务 OneDrive 和自有音乐流媒体平台 Xbox Music 相融合,从而允许用户将 Xbox Music Store 中没有的音乐上传至前者,并能在任何运行 Xbox  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLrwaM.html" rel="bookmark" class="title">java--多线程实现计数器</a>
					<div>
						同时开始5个线程,用各自的文本框显示count,和按钮控制count的自加 import java.awt.*; import java.awt.event.*; import java.applet ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlLamDM.html" rel="bookmark" class="title">linux编程-linux 问题  关于脚本的</a>
					<div>
						问题描述 linux 问题 关于脚本的 为什么在linux 终端一句一句的输入命令,可以出最终的结果,而把这些命令和在一起放在一个脚本里就不行了呢 解决方案 从windows拷贝到linux虚拟机中的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYXWJZb.html" rel="bookmark" class="title">新创公司GoInstant宣布，已经完成和云服务巨头企业Salesforce&period;com的收购交易，收购价格为7000万美元</a>
					<div>
						GoInstant公司致力于开发网页浏览新技术,通过这种技术用户可以无需下载插件,就能实现和他人共同浏览网页内容.GoInstant的联合创始人杰文·麦克唐纳(Jevon MacDonald),将他们 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmBJaDz.html" rel="bookmark" class="title">ios视频聊天怎样在后台或者退出应用时以推送的形式发送</a>
					<div>
						问题描述 现在环信的ios demo上视频通话不支持后台,怎样手动修改代码让应用在后台或者退出应用时以推送的形式发送 解决方案 暂时不支持后台接收实时音视频的推送额.					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQ1Ymwb.html" rel="bookmark" class="title">C&plus;&plus;编程中break语句和continue语句的学习教程&lowbar;C 语言</a>
					<div>
						break 语句break 语句可终止执行最近的封闭循环或其所在条件语句. 控制权将传递给该语句结束之后的语句(如果有的话). break; 备注 break 语句与 switch 条件语句以及 do ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEYn2Zb.html" rel="bookmark" class="title">jquery动态增加表格行或者列的例子</a>
					<div>
						分享一下代码吧! html &lt;div class=&quot;table-responsive&quot; id=&quot;Bk_table&quot; style=&quot;display ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5QKJRp.html" rel="bookmark" class="title">java 通过axis2 调用&period;net webservice 时传2维byte数组的问题</a>
					<div>
						问题描述 求大侠解答下java通过axis2调用.netwebservice时.netwebservice入参为一个byte类型的2维数组axis2是支持byte数组的但是2维的byte数组怎么设置入 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7jNAM.html" rel="bookmark" class="title">被带偏的智能家居，如何才能&OpenCurlyDoubleQuote;逃出生天&rdquo;</a>
					<div>
						近日,中兴在京召开了智能家居战略发布会,大喊包含&quot;单品.整合.开放&quot;三大要素的IOC产品战略.这把响铃的注意力再次拉回到这个&quot;看似热闹,实则不温不火&quot;的领域.2 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgE7dEz.html" rel="bookmark" class="title">下一代网络安全将全部基于行为识别</a>
					<div>
						本文讲的是 下一代网络安全将全部基于行为识别,从2014年造成7000万客户信息泄露的美国第二大零售商塔吉特数据泄露事件,到最近臭名昭著的偷情网站Ashley Madison被黑,各种数据泄露事件滔天 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.036 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
